/*
Copyright Renaud GICQUEL 2012  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableModel;

import java.awt.*;
import java.util.*;

/**
 * Classe pour modifier la composition d'un gaz pour ajuster son PCI
 * 
 * En pratique, on ajuste la part des inertes pour obtenir la valeur dsire
 * mais il n'ya pas de test sur le composant slectionn
 * 
 * Les fichiers de projet et de schma doivent comprendre une transfo-point
 * dont le corps est le gaz dont on cherche  ajuster le PCI.
 * 
 * Le PCI recherch ne peut bien sr excder le PCI en l'absence d'inertes.
 * Commencez par cliquer sur "Update the table" pour charger la composition
 * du gaz. Son PCI s'affiche en rouge
 * Entrez dans le champ "set LHV" la valeur dsire
 * Le bouton "Modify composition" essaie d'effectuer un ajustement de la fraction molaire
 * du composant slectionn dans la table.
 * Une fois le calcul effectu, cliquez sur "Update the table" pour actualiser la table
 * et itrez jusqu' obtenir la valeur dsire.
 * 
 * Quand la composition vous convient, ouvrez l'diteur de gaz composs  partir
 * de l'cran du point, et sauvegardez la composition sous un nouveau nom afin
 * de pouvoir y accder dans la liste des gaz composs non protgs
 *
 * @author Renaud GICQUEL
 */
public class PiloteAjustePCI extends ExtPilot
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]composant,nomComposant;
    String processName="",expansionName="",collectorName="";
    PointThopt inletPoint;
    rg.corps.Corps comburSubstance, newComburSubstance;
    int nbComp=1, lineSelect=-1;
   String[]nom_gaz_comp = new String[nbComp];
   Double[]fracMol= new Double[nbComp],fracMass= new Double[nbComp],molarMass= new Double[nbComp];
   Double LHV;
   Vector comburComp;
   double lhv;
   
	protected Object[][] data_t;
	protected Object[] nom_t;
	protected TableModel  dataModelt;
	protected JScrollPane scrollpanet;
	protected JTableHeader JTMt;
	protected JTable tableViewt;
    Vector vBranch;


	public PiloteAjustePCI()
	{
		   data_t= new Object[0][4];

		//{{INIT_CONTROLS
		setTitle("Combustion LHV driver");
		getContentPane().setLayout(null);
		setSize(671,413);
		setVisible(false);
		JLabel4.setText("gas LHV");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(420,252,156,24);
		LHV_value.setSelectionColor(new java.awt.Color(204,204,255));
		LHV_value.setSelectedTextColor(java.awt.Color.black);
		LHV_value.setCaretColor(java.awt.Color.black);
		LHV_value.setDisabledTextColor(java.awt.Color.lightGray);
		getContentPane().add(LHV_value);
		LHV_value.setForeground(java.awt.Color.red);
		LHV_value.setBounds(550,252,96,24);
		bCalculate.setText("Modify composition");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(468,96,156,60);
		bUpdateTable.setText("Update the table");
		bUpdateTable.setActionCommand("Update the table");
		getContentPane().add(bUpdateTable);
		bUpdateTable.setBounds(468,20,156,60);
		JLabel2.setText("set LHV");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(420,288,156,24);
		getContentPane().add(setLHV_value);
		setLHV_value.setBounds(550,288,96,24);
		setLHV_value.setSelectionColor(new java.awt.Color(204,204,255));
		setLHV_value.setSelectedTextColor(java.awt.Color.black);
		setLHV_value.setCaretColor(java.awt.Color.black);
		setLHV_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		setLHV_value.setText("44000.");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bCalculate.addActionListener(lSymAction);
		bUpdateTable.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}
		vBranch=new Vector();
		setTable_t();
		getContentPane().add(scrollpanet);
		scrollpanet.setBounds(0,50,400,300);
		scrollpanet.setBackground(getBackground());
		tableViewt.setBounds(0,50,400,290);
		SymMouse aSymMouse = new SymMouse();

		this.addMouseListener(aSymMouse);
		tableViewt.addMouseListener(aSymMouse);
		JTMt.addMouseListener(aSymMouse);

		type="combustion LHV";
	}

	public String getClassDescription(){
	    return "driver for setting LHV\n\nauthor : R. Gicquel october 2012";
	}

	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == PiloteAjustePCI.this)
			PiloteCombustion_WindowClosing(event);
		}
	}

	void PiloteCombustion_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField setLHV_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField LHV_value = new javax.swing.JTextField();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JButton bUpdateTable = new javax.swing.JButton();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bCalculate)
				bCalculate_actionPerformed(event);
			else if (object == bUpdateTable)
				bUpdateTable_actionPerformed(event);
		}
	}	
	/**
	 * generates the branch JTable
	 */

	private void setTable_t(){
		nom_t= new Object[4];
		nom_t[0]="Component";
		nom_t[1]="molar fraction";
	 	nom_t[2]="mass fraction";
	 	nom_t[3]="selected";

		dataModelt = new AbstractTableModel() {
			public int getColumnCount() { return nom_t.length; }
			public int getRowCount() { return data_t.length;}
			public Object getValueAt(int row, int col) {return data_t[row][col];}

			public String getColumnName(int column) {return (String) nom_t[column];}
			public boolean isCellEditable(int row, int col) {return false;}
			public String getType(){return "";}
				};
			tableViewt = new JTable(dataModelt);
			JTMt=tableViewt.getTableHeader();
	        tableViewt.getColumnModel().getColumn(3).setCellRenderer(
	        new DefaultTableCellRenderer(){//mise en place d'un checkbox dans la JTable
	            public Component getTableCellRendererComponent(JTable table,Object value,
	                   boolean isSelected,boolean hasFocus,int row,int column){
	                        Boolean boul=new Boolean(true);
	                        return (Component)new JCheckBox("",boul.equals(value));
	                    }
				public String getType(){return "";}
	        });

			scrollpanet = new JScrollPane(tableViewt);
			scrollpanet.setPreferredSize(new Dimension(400,200));
		}
	void bUpdateTable_actionPerformed(java.awt.event.ActionEvent event)
	{   //mise  jour de la table
	    updateTablet();
	}


	    /**
	    * updates the branch JTable
	    */
	    public void updateTablet(){
	    	 if(!isInitialized)init();
	         comburComp=comburSubstance.getGasComposition();
	    	   Object obj=(Object) comburComp.elementAt(0);
	    	   Integer nb_comp=(Integer)obj;
	    	   nbComp=nb_comp.intValue();
	    	   obj=(Object) comburComp.elementAt(1);
	    	   nom_gaz_comp = new String[nbComp];
	    	   fracMol= new Double[nbComp];
	    	   fracMass= new Double[nbComp];
	    	   molarMass= new Double[nbComp];
	    	   nom_gaz_comp =(String[]) obj;
	    	   obj=(Object) comburComp.elementAt(2);
	    	   fracMol =(Double[]) obj;
	    	   obj=(Object) comburComp.elementAt(3);
	    	   fracMass =(Double[]) obj;
	    	   obj=(Object) comburComp.elementAt(4);
	    	   molarMass =(Double[]) obj;
	    	   obj=(Object) comburComp.elementAt(5);
	    	   LHV =(Double) obj;
	    	   lhv=LHV.doubleValue();
	    	   LHV_value.setText(Util.aff_d(lhv,2));
		    vBranch=new Vector();
	 	    data_t= new Object[nbComp][4];

		    for(int i=0;i<nbComp;i++){
	            Object[] br=new Object[4];
	            br[0]=nom_gaz_comp[i];
	            br[1]=fracMol[i];
	            br[2]=fracMass[i];
	            br[3]=Util.aff_b(false);
	 		    data_t[i][0]=br[0];//nom
			    data_t[i][1]=br[1];//fraction molaire 
	 		    data_t[i][2]=br[2];//fraction massique 
	 		    data_t[i][3]=bool((String)br[3]);
	            vBranch.addElement(br);
	            
	        }
		    if(lineSelect!=-1)data_t[lineSelect][3]=bool("true");

		    tableViewt.revalidate();
		    repaint();
	    }


	    private Boolean bool(String s){
			if(s.equals("true"))return new Boolean(true);
			else return new Boolean(false);
		}

		public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		//Retrieves the list and the type of components in the diagram editor
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
		//on en extrait les noms de la transfo-point
		//gets the name of compression et expansionthe process-point
		processName="";
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
//	        System.out.println("composant[i] "+composant[i]);
//	        System.out.println("nomComposant[i] "+nomComposant[i]);
		    if(composant[i].equals("ProcessPoint")){
		    	processName=nomComposant[i];
		    	break;
		    }
        }
        if(processName.equals("")){
 		   String msg = "The project and diagram should be comprised of a process-point\n" +
 		   		"with as substance the gas whose LHV is to be modified\n" +
 		   		"Restart Thermoptim and open appropriate project and diagram files";
           JOptionPane.showMessageDialog(this, msg);  
        	
        }
        else{
        //test de cohrence (des messages d'erreur plus prcis seraient souhaitables)
        //consistency test (error messages should be an improvement)
        String[] args=new String[2];
        args[0]="process";
        args[1]=processName;
        System.out.println("processName "+processName);
        Vector vProp=proj.getProperties(args);
        String amont=(String)vProp.elementAt(1);//point amont //inlet point
        
        inletPoint=new PointThopt(proj,amont);//instanciation du PointThopt correspondant au point amont
        
        if(!processName.equals(""))isBuilt=true;
           comburSubstance=inletPoint.lecorps;//le gaz  modifier
           comburComp=comburSubstance.getGasComposition();//chargement de la composition du gaz dans le Vector
           
    	   Object obj=(Object) comburComp.elementAt(0);
    	   Integer nb_comp=(Integer)obj;
    	   nbComp=nb_comp.intValue();//nombre de composants
    	   
    	   nom_gaz_comp = new String[nbComp];
    	   fracMol= new Double[nbComp];
    	   fracMass= new Double[nbComp];
    	   molarMass= new Double[nbComp];
    	   
    	   obj=(Object) comburComp.elementAt(1);//noms des composants
    	   nom_gaz_comp =(String[]) obj;
    	   obj=(Object) comburComp.elementAt(2);//fractions molaires
    	   fracMol =(Double[]) obj;
    	   obj=(Object) comburComp.elementAt(3);//fractions massiques
    	   fracMass =(Double[]) obj;
    	   obj=(Object) comburComp.elementAt(4);//masses molaires
    	   molarMass =(Double[]) obj;
    	   obj=(Object) comburComp.elementAt(5);//PCI
    	   LHV =(Double) obj;
    	   lhv=LHV.doubleValue();
    	   LHV_value.setText(Util.aff_d(lhv,2));
        }
  	   
/*       for(int i=0;i<nbComp;i++){
    	   System.out.println(nom_gaz_comp[i]+"  "+fracMol[i]+"  "+fracMass[i]+"  "+molarMass[i]+"  ");
      }*/

		if(isBuilt)setVisible(true);//on n'ouvre le pilote que si sa structure est correcte
		                    //the driver cannot be open if its structure is wrong
	}
	
    
    void setupProject(){
  }
	
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            //the initialization is made during the first call, as the constructor 
	                            //must have no argument because the class is instanciated by the RMI
	    
	    if(lineSelect!=-1){//pour le premier calcul, on cherche la valeur max du PCI obtenue pour une fraction molaire nulle des inertes
	    	double fractVar=Util.molarComp(comburComp,nom_gaz_comp[lineSelect]);//fraction molaire  faire varier
	    	double oldLHV=lhv;
	    	
	        for(int i=0;i<nbComp;i++){//nouvelles valeurs des fractions molaires
	     	   double f=fracMol[i].doubleValue()/(1-fractVar);
	     	  fracMol[i]=new Double(f);
	       }
	     	  fracMol[lineSelect]=new Double(0.);//0 pour celle qui varie

	        Vector vComp=new Vector();//la nouvelle composition est charge dans le Vector (seules les fractions molaires sont prises en compte)
	        vComp.addElement(new Integer(nbComp));
	        vComp.addElement(nom_gaz_comp);
	        vComp.addElement(fracMol);
	        vComp.addElement(fracMol);
	        vComp.addElement(molarMass);
	        
	        newComburSubstance=Util.createIdealGas("combustible 2");//cration d'un nouveau gaz compos
	        newComburSubstance.updateGasComposition(vComp);//modification de la composition du gaz
	        
	        Vector newComburComp=newComburSubstance.getGasComposition();//rcupration de la composition recalcule
	 	    Object obj=(Object) newComburComp.elementAt(5);//PCI
	 	    Double LHV0 =(Double) obj;
		    double lhv0=LHV0.doubleValue();
		    double setLHV=Util.lit_d(setLHV_value.getText());
		   
		   if(lhv0<setLHV){
			   String msg = "Watch out:\nThe maximum LHV value with this fuel composition is "+lhv0;
	           JOptionPane.showMessageDialog(this, msg);  
		   }
		   else{//on modifie la fraction molaire proportionnellement au changement de PCI dsir
			   //en oprant de manire analogue  ce qui vient d'tre fait
			   double newFract=fractVar/(lhv0-oldLHV)*(lhv0-setLHV);
			   
		       for(int i=0;i<nbComp;i++){
		     	   double f=fracMol[i].doubleValue()*(1-newFract);
		     	  fracMol[i]=new Double(f);
		       }
		     	fracMol[lineSelect]=new Double(newFract);
			   
		     	vComp=new Vector();
		        vComp.addElement(new Integer(nbComp));
		        vComp.addElement(nom_gaz_comp);
		        vComp.addElement(fracMol);
		        vComp.addElement(fracMol);
		        vComp.addElement(molarMass);
		         
		        newComburSubstance.updateGasComposition(vComp);//modification de la composition du gaz
		   	   	
		        comburSubstance.updateGasComposition(vComp);//on met  jour le gaz du projet
		   }
	    }
	   else{
		   String msg = "Click one of the lines corresponding to inert gases in order to check it";
           JOptionPane.showMessageDialog(this, msg);  
	   }
	}
    class SymMouse extends java.awt.event.MouseAdapter{
        public void mousePressed(java.awt.event.MouseEvent event){
                Projet_mousePressed(event);
        }
    }
	void Projet_mousePressed(java.awt.event.MouseEvent event){
	    Object object = event.getSource();
	    int nb_click=event.getClickCount();
	    if(nb_click>=1){   //slectionne ou dslectionne le gaz  changer
	        if (object == tableViewt){
                int nb_select =tableViewt.getSelectedRowCount() ;
               if (nb_select!=1){//trop de lignes slectionnes
                    JOptionPane.showMessageDialog(this, "Select a single line");
                    this.setVisible(true);//ractive la fentre dsactive par JOptionPane
                }
                else{//1 ligne slectionne
	                int line=tableViewt.getSelectedRow();
			        Object[]branch=(Object[])vBranch.elementAt(line);
		            String br=(String)branch[3];
                    boolean plot=Util.lit_b(br) ;
                    if(plot)branch[3]="false";
		            else branch[3]="true";
		            vBranch.setElementAt(branch,line);
		            for(int i=0;i<nbComp;i++){
		            	data_t[i][3]=bool("false");
		 	         }
		            data_t[line][3]=bool("true");
		            lineSelect=line;
		            tableViewt.revalidate();
		            repaint();
	            }
            }
	    }
	}

}